from twisted.web import client
from twisted.internet import reactor, defer, threads

import bz2


@defer.inlineCallbacks
def worker(n):
    url = "http://www.taniquetil.com.ar/testfiles/tf{}.bz2".format(n)
    print("Start", n)
    compressed = yield client.getPage(url.encode('ascii'))
    print("Read", n)
    data = yield threads.deferToThread(bz2.decompress, compressed)
    print("Decompressed", n, len(data))


@defer.inlineCallbacks
def go():
    deferreds = []
    for i in range(10):
        d = worker(i)
        deferreds.append(d)
    yield defer.DeferredList(deferreds)
    print("Done")
    reactor.stop()


reactor.callWhenRunning(go)
reactor.run()
